var book = minimvc.model.create({
    author: 'Stoyan Stefanov',
    title: 'JavaScript Patterns'
});

var formView = minimvc.view.create({
    el: '#bookForm',
    model: book,
    template: _.template($('#bookForm-template').html()),

    initialize: function() {
        // this.model.addObserver('change', this.render.bind(this));
        this.model.addObserver('change', this.updateView.bind(this));
        this.render(this.model.toJSON());
    },

    render: function(data) {
        $(this.el).html(this.template(data));
    },

    updateView: function(data) {
        $(this.el).find('#txtTitle').val(data.title);
        $(this.el).find('#txtAuthor').val(data.author);
    }
});
// formView.initialize();

var panelView = minimvc.view.create({
    el: '#bookPanel',
    model: book,
    template: _.template($('#bookPanel-template').html()),

    initialize: function() {
        this.model.addObserver('change', this.render.bind(this));
        this.render(this.model.toJSON());
    },

    render: function(data) {
        $(this.el).html(this.template(data));
    }
});
// panelView.initialize();

var bookController = minimvc.controller.create({
    model: book,
    formView: formView,
    panelView: panelView,

    events: {
        '#txtTitle.keyup': 'writing',
        '#txtAuthor.keyup': 'writing'
    },

    initialize: function() {
        this.formView.initialize();
        this.panelView.initialize();
    },

    writing: function(e) {
        this.model.set('title', $('#txtTitle').val());
        this.model.set('author', $('#txtAuthor').val());
    }
});

bookController.initialize();