(function(exports) {


    exports.extendDeep = function extendDeep(objTo, objFrom) {

        var copy = function copy(objTo, objFrom, prop) {
            if (typeof objFrom[prop] === "object") {
                objTo[prop] = (Object.prototype.toString.call(objFrom[prop]) === '[object Array]') ? [] : {};
                extendDeep(objTo[prop], objFrom[prop]);
            } else {
                objTo[prop] = objFrom[prop];
            }
        }

        if (arguments[2] && typeof arguments[2] === 'string') {
            for (var i = 2; i < arguments.length; i++) {
                var prop = arguments[i];
                copy(objTo, objFrom, prop);
            }
        } else {
            [].slice.call(arguments, 1).forEach(function(source) {
                for (var prop in source) {
                    if (source.hasOwnProperty(prop)) {
                        copy(objTo, source, prop);
                    }
                }
            });
        }
        return objTo;
    };


})((typeof exports === 'undefined') ? window : exports);