// var ok = require('../objects/test.js').ok;
// var test = require('../objects/test.js').test;

// var extendDeep = require('../objects/extendDeep.js').extendDeep;
// var extendShallow = require('../objects/extendShallow.js').extendShallow;
// var extendFunc = require('../objects/extendFunc.js').extendFunc;
// var observable = require('../patterns/observable.js').observable;

// var _ = require('../objects/underscore');

var minimvc = {};

minimvc.model = (function() {
    var proto = extendDeep({
        get: function(attr) {
            return this.attributes[attr];
        },
        set: function(attr, val) {
            this.attributes[attr] = val;
            this.notify('change:' + attr, val);
            this.notify('change', this.attributes);
        },
        toJSON: function() {
            return _.clone(this.attributes);
        }
    }, observable);

    return {
        create: function(attrs) {
            return extendShallow(Object.create(proto), {
                id: _.uniqueId('model'),
                attributes: attrs || {}
            });
        }
    };
})();

minimvc.view = (function() {
    var proto = {}; //extendDeep({}, observable);

    return {
        create: function(attrs) {
            return extendShallow(Object.create(proto), {
                id: _.uniqueId('view')
            }, attrs || {});
        }
    };
})();

minimvc.controller = (function() {
    var proto = {}; //extendDeep({}, observable);

    return {
        create: function(attrs) {
            var obj = extendShallow(Object.create(proto), {
                id: _.uniqueId('controller')
            }, attrs || {});

            if (attrs.events) {
                _.each(attrs.events, function(methodName, domEventName) {
                    var parts = domEventName.split('.');
                    var selector = parts[0];
                    var eventType = parts[1];
                    $(document).on(eventType, selector, function(e) {
                        obj[methodName](e);
                    });
                });
            }

            return obj;
        }
    };
})();