(function(exports) {


    var observable = {
        observers: {},
        addObserver: function(type, fn) {
            if (typeof this.observers[type] === "undefined") {
                this.observers[type] = [];
            }
            this.observers[type].push(fn);
        },
        removeObserver: function(type, fn) {
            var i,
                observers = this.observers[type];
            for (i = 0; i < observers.length; i += 1) {
                if (observers[i] === fn) {
                    observers.splice(i, 1);
                }
            }
        },
        notify: function(type) {
            var i,
                observers = this.observers[type] || [],
                allObservers = this.observers['all'] || [],
                args = [].slice.call(arguments, 1);
            for (i = 0; i < observers.length; i += 1) {
                observers[i].apply(this, args);
            }
            if (allObservers.length > 0) {
                //console.log(arguments, allObservers[0].toString())
                for (i = 0; i < allObservers.length; i += 1) {
                    allObservers[i].apply(null, arguments);
                }
            }
        }
    };

    exports.observable = observable;



})((typeof exports === 'undefined') ? window : exports);